:: converttrafrancais.bat V1.1
:: V1.0 :
:: - version initiale basique
:: V1.1 :
:: - ajout de contrles en cas de rpertoire franais non trouv ou de backup dj cr
:: - correction de la prise en compte du rpertoire franais (c cdille en codage DOS)
:: - changement de nom du rpertoire de sauvegarde des fichiers d'origine (plus lisible)
:: V1.2 :
:: - copie le rpertoire au lieu de le renommer (conservation des fichiers autres que les .tra)
:: - prise en compte des sous-rpertoires contenant des .tra (ncessaire pour certains mods), sur un seul niveau
@echo off

set nomorigine=

if exist .\french set nomorigine=french
if exist .\francais set nomorigine=francais
if exist .\franais set nomorigine=franais

if "%nomorigine%" EQU "" goto erreurRepNonTrouve

:: Si -old existe (v1.0) ou -avantUTF8 existe (V1.1), on ne fait rien
if exist %nomorigine%-old goto dejaConverti
if exist %nomorigine%-avantUTF8 goto dejaConverti

:: Renommmage du rpertoire d'origine avant la conversion, afin de conserver au final
:: le nom de rpertoire voulu par le mod pour le contenu en UTF-8.
:: Plutt une copie, car certains mods ont d'autres fichiers que les .tra dans le rpertoire
:: notamment des readmes.
::ren %nomorigine% %nomorigine%-avantUTF8
::mkdir %nomorigine%
xcopy %nomorigine% %nomorigine%-avantUTF8 /E /C /I /Q

:: Les fichiers  convertir sont les fichiers .tra
:: L'ajout des fichiers .tpa correspond  un besoin du BG2 Tweak Pack

:: ~nx sert  indiquer qu'on ne veut que le nom du fichier (n) avec extension (x) et pas le chemin complet
:: http://technet.microsoft.com/en-us/library/cc755694%28WS.10%29.aspx
:: Voir manuel iconv
:: -f pour indiquer l'encodage du fichier d'origine (ici CP1252 / WINDOWS-1252 / ISO8859-1 pour le Franais)
:: -t pour indiquer l'encodage final (UTF-8)
for %%i in (%nomorigine%-avantUTF8\*.tra %nomorigine%-avantUTF8\*.tpa) do iconv -f CP1252 -t UTF-8 "%nomorigine%-avantUTF8\%%~nxi" > "%nomorigine%\%%~nxi"

:: Prise en compte d'ventuels sous-rpertoires (DKUP, ...) : un niveau seulement
for /F "tokens=1 delims=	" %%r in ('dir /ad /b %nomorigine%-avantUTF8\') do (
  for %%i in ("%nomorigine%-avantUTF8\%%r\*.tra" "%nomorigine%-avantUTF8\%%r\*.tpa") do iconv -f CP1252 -t UTF-8 "%nomorigine%-avantUTF8\%%r\%%~nxi" > "%nomorigine%\%%r\%%~nxi"
)

echo Conversion terminee dans le repertoire %nomorigine%.
echo.
pause
exit

:dejaConverti
echo Le repertoire %nomorigine%-old ou %nomorigine%-avantUTF8 existe deja : conversion deja faite.
echo.
pause
exit


:erreurRepNonTrouve
echo Repertoire french, francais ou franais non trouve. Conversion impossible.
echo.
pause
exit
