#!/bin/bash

# converttrafrancais.sh V1.3
# V1.0 : Windows uniquement
# - version initiale basique
# V1.1 : Windows uniquement
# - ajout de contrles en cas de rpertoire franais non trouv ou de backup dj cr
# - correction de la prise en compte du rpertoire franais (c cdille en codage DOS)
# - changement de nom du rpertoire de sauvegarde des fichiers d'origine (plus lisible)
# V1.2 : Windows uniquement
# - copie le rpertoire au lieu de le renommer (conservation des fichiers autres que les .tra)
# - prise en compte des sous-rpertoires contenant des .tra (ncessaire pour certains mods), sur un seul niveau
# V1.3 :
# - adaptation sous Linux / Mac

nomorigine=""

if [ -d ./french ]; then
	nomorigine=french
fi
if [ -d ./francais ]; then
	nomorigine=francais
fi
if [ -d ./franais ]; then
	nomorigine=franais
fi

if [ -z $nomorigine ]; then
	echo Repertoire french, francais ou franais non trouve. Conversion impossible.
	exit 1;
fi

# Si -old existe (v1.0) ou -avantUTF8 existe (V1.1), on ne fait rien
if [ -d $nomorigine-old -o -d $nomorigine-avantUTF8 ]; then
	echo Le repertoire $nomorigine-old ou $nomorigine-avantUTF8 existe deja : conversion deja faite.
	exit 1
fi

# Renommmage du rpertoire d'origine avant la conversion, afin de conserver au final
# le nom de rpertoire voulu par le mod pour le contenu en UTF-8.
# Plutt une copie, car certains mods ont d'autres fichiers que les .tra dans le rpertoire
# notamment des readmes.
cp -pR $nomorigine $nomorigine-avantUTF8

# Les fichiers  convertir sont les fichiers .tra
# L'ajout des fichiers .tpa correspond  un besoin du BG2 Tweak Pack

# Voir manuel iconv
# -f pour indiquer l'encodage du fichier d'origine (ici CP1252 / WINDOWS-1252 / ISO8859-1 pour le Franais)
# -t pour indiquer l'encodage final (UTF-8)
for file in $(ls "$nomorigine"-avantUTF8/*.tra "$nomorigine"-avantUTF8/*.tpa 2>/dev/null) 
do
	iconv -f CP1252 -t UTF-8 "$file" > ${file/-avantUTF8//}
done

# Prise en compte d'ventuels sous-rpertoires (DKUP, ...) : un niveau seulement
for dir in $(ls "$nomorigine"-avantUTF8)
do
	if [ -d $nomorigine-avantUTF8/$dir ]; then
		for file in $(ls "$nomorigine"-avantUTF8/$dir/*.tra "$nomorigine"-avantUTF8/$dir/*.tpa 2>/dev/null) 
		do
		  iconv -f CP1252 -t UTF-8 "$file" > ${file/-avantUTF8//}
		done
	fi
done

echo Conversion terminee dans le repertoire $nomorigine
exit 0
